/* st_main - test routine for stack package
 */
#include "local.h"
#include "stack.h"

#define NAME_NODE struct name_node
NAME_NODE
	{
	NAME_NODE *next;
	char data[4];
	};
NAME_NODE *head = NULL;		/* head node of stack */
NAME_NODE *p = NULL;		/* current node */
void show_cmds(), push_name(), pop_name(), dump_names();
																					                                                                         /*
.PE
.PS 26
/* st_main (main) */
main()
	{
	char buf[2];			/* buffer for input */

	ST_OPEN(&head);			/* open the stack */
	show_cmds();
	while (getreply("?: ", buf, 2) != EOF)
		{
		switch (buf[0])
			{
		case '+':
			push_name();
			break;
		case '-':
			pop_name();
			break;
		case '=':
			dump_names();
			break;
		case '0':
			ST_CLOSE(&head);
			ST_OPEN(&head);		/* open the stack again */
			break;
		case '?':
			show_cmds();
			break;
		default:
			printf("unknown command: %c\n", buf[0]);
			show_cmds();
			break;
			}
		}
	exit(SUCCEED);
	}																															                                                          /*
.PE
.PS  30
/* show_cmds -- show legal commands */
void show_cmds()
	{
	printf("Type + to push, - to pop, = to print, 0 to reset:\n");
	}
/* push_name - push new name on stack */
void push_name()
	{
	p = (NAME_NODE *)malloc(sizeof(NAME_NODE));
	if (p == NULL)
		error("out of space", "");
	if (getreply("name: ", p->data, 4) == EOF)
		 error("unexpected EOF", ""); 
	ST_PUSH(&head, p);
	}
/* pop_name - pop a name off stack */
void pop_name()
	{
	p = (NAME_NODE *)ST_POP(&head);
	if (p == NULL)
		printf("EMPTY STACK\n");
	else
		{
		printf("name= %s\n", p->data);
		free(p);
		}
	}
/* dump_names - print the current stack of names */
void dump_names()
	{
	if (ST_IS_EMPTY(head))
		printf("EMPTY STACK\n");
	else
		EACH_ST(head, p)
			printf("name= %s\n", p->data);
	}
